SET SCOREBOARD OFF
SET TALK OFF
SET STATUS OFF

CLOSE ALL
SELECT 3
   USE XTAB_DEF
   SET SAFETY OFF
   ZAP
SELECT 1

PUBLIC ROW,COLUMN,FIELDS

CLEAR

DEFINE POPUP DBF    FROM 04,01 TO 17,15 PROMPT FILES LIKE *.DBF ;
   MESSAGE "SELECT A FILE"
DEFINE POPUP ROW    FROM 04,01 TO 17,15 PROMPT STRUCTURE ;
   MESSAGE "CHOOSE FIELD TO CROSS TABULATE ON"
DEFINE POPUP COLUMN FROM 04,01 TO 17,15 PROMPT STRUCTURE ;
    MESSAGE "CHOOSE FIELD TO CROSS TABULATE BY"

ON SELECTION POPUP DBF    DO GET_FILE
ON SELECTION POPUP ROW    DO GET_ROW
ON SELECTION POPUP COLUMN DO GET_COLUMN

TITLE="< C R O S S   T A B >"
@01,40-(LEN(TITLE)/2) SAY TITLE

@04,20 SAY "Ŀ"
@05,20 SAY "  CROSS                                              "
@06,20 SAY "   TAB    Ĵ"
@07,20 SAY "                                                  "
@08,20 SAY "Ĵ"
@09,20 SAY "          XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
@10,20 SAY "Ĵ"
@11,20 SAY "  MATRIX CELLS = ROWS x COLUMNS x #FIELDS             "  
@12,20 SAY ""

MATRIX="ROWS x COLUMNS x #FIELDS"

ACTIVATE POPUP DBF
   @19,01 SAY "FILE        : "+PROMPT()
   SET SAFETY OFF
      COPY TO XTAB_TMP STRUCTURE EXTENDED
   SET SAFETY ON

ACTIVATE POPUP ROW
   @20,01 SAY "CROSS TAB ON: "+ROW
   SET SAFETY OFF
   INDEX ON &ROW TO CT_ROW UNIQUE
   SET SAFETY ON
   COUNT TO ROW_N
   DECLARE ARRAY[ROW_N,2]
   COPY TO ARRAY ARRAY FIELDS &ROW 
   @09,21 SAY ROW
   @11,38 SAY REPLICATE(" ",LEN(MATRIX))
   @11,38 SAY LTRIM(STR(ROW_N))+SUBSTR(MATRIX,5)
   SELECT 2
      USE XTAB_TMP
      DECLARE N_FIELD[RECCOUNT(),3]
      COPY TO ARRAY N_FIELD FIELDS FIELD_NAME,FIELD_TYPE
      DELETE FOR FIELD_NAME<>ROW
      PACK
   SELECT 1

ACTIVATE POPUP COLUMN
   @21,01 SAY "CROSS TAB BY: "+COLUMN
   SET SAFETY OFF
   INDEX ON &COLUMN TO CT_TMP UNIQUE
   SET SAFETY ON
   @05,49 SAY COLUMN
   COUNT TO COL_N
   DECLARE ACOLUMN[COL_N,2]
   COPY TO ARRAY ACOLUMN FIELDS &COLUMN
   @11,38 SAY REPLICATE(" ",LEN(MATRIX))
   @11,38 SAY LTRIM(STR(ROW_N))+" x "+LTRIM(STR(COL_N))+SUBSTR(MATRIX,15)

DEFINE POPUP FIELDS FROM 04,01 TO 17,15 MESSAGE "SELECT FIELDS TO BE INCLUDED IN CROSS TAB"
ON SELECTION POPUP FIELDS DO GET_FIELDS
I=1
DO WHILE LEN(FIELD(I))>0
   IF N_FIELD[I,2]="N"
      DEFINE BAR I OF FIELDS PROMPT N_FIELD[I,1] 
   ELSE
      DEFINE BAR I OF FIELDS PROMPT N_FIELD[I,1] SKIP
   ENDIF
   I=I+1
ENDDO

N=0
TMP_STRING="FIELDS      : "
TMP_ITEM=""
DECLARE AFIELDS[4,2]
ACTIVATE POPUP FIELDS
SET INDEX TO
SET SAFETY OFF
   SELECT 2
   CREATE XTAB FROM XTAB_TMP
SET SAFETY ON
APPEND FROM ARRAY ARRAY
SELECT 2
@12,20 SAY "Ĵ"
@13,20 SAY "  MATRIX ROWS COMPLETE :                              "  
@14,20 SAY ""

   GOTO TOP
   DO WHILE .NOT. EOF()
      I=1
      TMP_VALUE=&ROW
      DO WHILE I<=COL_N
         J=1
         DO WHILE J<=N
            SELECT 1
            CALCULATE SUM(&AFIELDS[J,1]) FOR &COLUMN=ACOLUMN[I,1] .AND.;
                      &ROW=TMP_VALUE TO ANSWER
            SELECT 2
            TMP_FIELD="X_"+RTRIM(LTRIM(STR(I)))+"_"+LTRIM(STR(J))
            REPLACE &TMP_FIELD WITH ANSWER
            J=J+1
         ENDDO
         I=I+1
      ENDDO
      @13,47 SAY RECNO()
      @13,60 SAY RECNO()/ROW_N*100 PICTURE "999.99%"
      SKIP
   ENDDO

* PROCEDURES

PROCEDURE GET_FILE
   USE PROMPT()
   DEACTIVATE POPUP
RETURN

PROCEDURE GET_ROW
   ROW=PROMPT()
   DEACTIVATE POPUP
RETURN

PROCEDURE GET_COLUMN
   COLUMN=PROMPT()
   DEACTIVATE POPUP
RETURN

PROCEDURE GET_FIELDS
   IF AT(PROMPT()+"+",TMP_STRING)=0 .AND. AT("+"+PROMPT(),TMP_STRING)=0
      TMP_STRING=IIF(LEN(TMP_STRING)=14,TMP_STRING+RTRIM(PROMPT()),TMP_STRING+"+"+RTRIM(PROMPT()))
      TMP_ITEM=IIF(LEN(TMP_STRING)=14,TMP_ITEM+RTRIM(PROMPT()),;
         TMP_ITEM+RTRIM(PROMPT())+REPLICATE(" ",10-LEN(RTRIM(PROMPT())))+CHR(179))
   ENDIF
   @22,01 SAY TMP_STRING
   @07,32 SAY SUBSTR(TMP_ITEM,1,79-35)
   N=N+1
   @11,38 SAY LTRIM(STR(ROW_N))+" x "+LTRIM(STR(COL_N))+" x "+LTRIM(STR(N));
              +" = "+LTRIM(STR(ROW_N*COL_N*N))
   I=1
   DO WHILE I <= COL_N
      SELECT 1
         GOTO TOP
         SKIP I-1
         TMP_FIELD=LTRIM(RTRIM(&COLUMN))
      SELECT 2
         APPEND BLANK
         REPLACE FIELD_NAME WITH "X_"+RTRIM(LTRIM(STR(I)))+"_"+LTRIM(STR(N)),;
                 FIELD_TYPE WITH "N",;
		 FIELD_LEN  WITH 12,;
		 FIELD_DEC  WITH 2,;
		 FIELD_IDX  WITH "N"
      SELECT 3
         APPEND BLANK
         REPLACE FIELD_DESC WITH TMP_FIELD+"-"+PROMPT(),;
                 FIELD_NAME WITH "X_"+RTRIM(LTRIM(STR(I)))+"_"+LTRIM(STR(N))
         AFIELDS[N,1]=PROMPT()
      SELECT 1
      I=I+1
   ENDDO
   IF N=4
      DEACTIVATE POPUP
   ENDIF
RETURN
